Codeforces Round #379 (Div. 2) E. Anton and Tree 缩点 直径

E. Anton and Tree

题目连接:

http://codeforces.com/contest/734/problem/E

Description

Anton is growing a tree in his garden. In case you forgot, the tree is a connected acyclic undirected graph.

There are n vertices in the tree, each of them is painted black or white. Anton doesn’t like multicolored trees, so he wants to change the tree such that all vertices have the same color (black or white).

To change the colors Anton can use only operations of one type. We denote it as paint(v), where v is some vertex of the tree. This operation changes the color of all vertices u such that all vertices on the shortest path from v to u have the same color (including v and u). For example, consider the tree

and apply operation paint(3) to get the following:

Anton is interested in the minimum number of operation he needs to perform in order to make the colors of all vertices equal.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 200 000) — the number of vertices in the tree.

The second line contains n integers colori (0 ≤ colori ≤ 1) — colors of the vertices. colori = 0 means that the i-th vertex is initially painted white, while colori = 1 means it’s initially painted black.

Then follow n - 1 line, each of them contains a pair of integers ui and vi (1 ≤ ui, vi ≤ n, ui ≠ vi) — indices of vertices connected by the corresponding edge. It’s guaranteed that all pairs (ui, vi) are distinct, i.e. there are no multiple edges.

Output

Print one integer — the minimum number of operations Anton has to apply in order to make all vertices of the tree black or all vertices of the tree white.

Sample Input

11
0 0 0 1 1 0 1 0 0 1 1
1 2
1 3
2 4
2 5
5 6
5 7
3 8
3 9
3 10
9 11

Sample Output

2

Hint

题意

给你一棵树,每个树上的节点要么是1,要么是0

每次操作你可以指定任何一个节点,然后使得这个节点周围的同色连通块变色。

问你最少花费多少次,使得整个树都是一个颜色。

题解:

显然缩点,缩点之后,我们把直径找出来,显然答案就是直径+1除以2

因为你在缩直径的时候,会把枝叶顺便给缩了,每次会减小2的长度。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e5+7;
int n,c[maxn];
vector<int> E[maxn];
pair<int,int> dfs(int x,int fa,int deep){
    pair<int,int> tmp=make_pair(deep,x);
    for(int i=0;i<E[x].size();i++){
        int v = E[x][i];
        if(v==fa)continue;
        if(c[v]!=c[x])tmp=max(tmp,dfs(v,x,deep+1));
        else tmp=max(tmp,dfs(v,x,deep));
    }
    return tmp;
}
int main()
{
    scanf("%d",&n);
    for(int i=1;i<=n;i++)scanf("%d",&c[i]);
    for(int i=1;i<n;i++){
        int a,b;
        scanf("%d%d",&a,&b);
        E[a].push_back(b);
        E[b].push_back(a);
    }
    pair<int,int> tmp=dfs(1,-1,0);
    tmp=dfs(tmp.second,-1,0);
    cout<<(tmp.first+1)/2<<endl;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/6069471.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞